###
### SMESH MODULE
###

import  SMESH, SALOMEDS
from salome.smesh import smeshBuilder

smesh = smeshBuilder.New()
main_mesh = smesh.Mesh(partition)


Regular_1D = main_mesh.Segment()
Max_Size_1 = Regular_1D.MaxSize(0.01)
MEFISTO_2D = main_mesh.Triangle(algo=smeshBuilder.MEFISTO)
Length_From_Edges_1 = MEFISTO_2D.LengthFromEdges()

# NETGEN 1D-2D algorithm
# NETGEN_1D_2D = main_mesh.Triangle(algo=smeshBuilder.NETGEN_1D2D)
# NETGEN_2D_Parameters_1 = NETGEN_1D_2D.Parameters()
# NETGEN_2D_Parameters_1.SetSecondOrder( 0 )
# NETGEN_2D_Parameters_1.SetOptimize( 1 )
# NETGEN_2D_Parameters_1.SetUseSurfaceCurvature( 1 )
# NETGEN_2D_Parameters_1.SetFuseEdges( 1 )
# NETGEN_2D_Parameters_1.SetQuadAllowed( 0 )
# NETGEN_2D_Parameters_1.SetChordalError( 0.01 )
# NETGEN_2D_Parameters_1.SetChordalErrorEnabled( 0 )
# NETGEN_2D_Parameters_1.SetMaxSize( 0.1 )
# NETGEN_2D_Parameters_1.SetFineness( 4 )
# NETGEN_2D_Parameters_1.SetMinSize( 0.0005 )

report("Computing mesh...")
isDone = main_mesh.Compute()

if not isDone:
    report("Mesh computation failed")
else:
    report("Mesh computed")

    sub_meshes = []

    for name in groups:
        sub_mesh = main_mesh.GetSubMesh(groups[name]['group'], name)
        sub_meshes.append(sub_mesh)

        try:
            file_name = os.path.join(study_dir, output_dir, name + ".stl")

            report("Exporting to {}...".format(file_name))
            main_mesh.ExportSTL(file_name, 1, sub_mesh)
            report("Mesh exported")
        except:
            report("ExportPartToSTL() failed.")
    
    ## Set names of Mesh objects
    #smesh.SetName(Regular_1D.GetAlgorithm(), 'Regular_1D')
    #smesh.SetName(MEFISTO_2D.GetAlgorithm(), 'MEFISTO_2D')
    #smesh.SetName(Max_Size_1, 'Max Size_1')
    #smesh.SetName(Mesh_1.GetMesh(), 'Mesh_1')
    #smesh.SetName(Sub_mesh_3, 'Sub-mesh_3')
    #smesh.SetName(Sub_mesh_2, 'Sub-mesh_2')
    #smesh.SetName(Sub_mesh_1, 'Sub-mesh_1')

    report("Done.")

    if salome.sg.hasDesktop():
        salome.sg.updateObjBrowser()
